/* Generated by GOB (v2.0.11)   (do not edit directly) */



/***************************************************************************
                          gtk-xine.gob  -  Xine Gtk Widget
                             -------------------
    begin                : dim jan  26 02:08:47 BST 2002
    copyright            : (C) 2002, 2004, 2005 by Stéphane Konstantaropoulos
    email                : stephane@cs.york.ac.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
 * Code taken / inspired from gtk-xine.c from the totem project by Hadess
 * 
 * Thanks go to him for his nice implementation
 * 	Copyright (C) 2001-2002 the xine project
 * 	Heavily modified by Bastien Nocera <hadess@hadess.net>
 * 
 * My modifications:
 * Use gob for easier syntax, remove signals and a few properties,
 * remove fullscreen code. Implement fully LumPlayer.
 *
 * #TODO apply LumConfig fully. Remove unnecessary things.
 */

#include <glib.h>
#include <glib-object.h>
#ifndef __GTK_XINE_H__
#define __GTK_XINE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <xine.h>
#include <gtk/gtk.h>
#include "lum-player.h"
#include "gtk-xine-info.h"



typedef enum {
	SPEED_PAUSE,
	SPEED_NORMAL
} GtkXineSpeed;
#define GTK_TYPE_XINE_SPEED gtk_xine_speed_get_type()
GType gtk_xine_speed_get_type (void);


typedef enum {
	GTK_XINE_ERROR_NONE,
	GTK_XINE_ERROR_NO_INPUT_PLUGIN,
	GTK_XINE_ERROR_NO_DEMUX_PLUGIN,
	GTK_XINE_ERROR_DEMUX_FAILED,
	GTK_XINE_ERROR_MALFORMED_MRL,
	GTK_XINE_ERROR_INPUT_FAILED
} GtkXineError;
#define GTK_TYPE_XINE_ERROR gtk_xine_error_get_type ()
GType gtk_xine_error_get_type (void);

#define GTK_XINE_ERROR gtk_xine_error_quark ()
GQuark gtk_xine_error_quark (void);


/*
 * Type checking and casting macros
 */
#define GTK_TYPE_XINE	(gtk_xine_get_type())
#define GTK_XINE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gtk_xine_get_type(), GtkXine)
#define GTK_XINE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gtk_xine_get_type(), GtkXine const)
#define GTK_XINE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gtk_xine_get_type(), GtkXineClass)
#define GTK_IS_XINE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gtk_xine_get_type ())

#define GTK_XINE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gtk_xine_get_type(), GtkXineClass)

/* Private structure type */
typedef struct _GtkXinePrivate GtkXinePrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GTK_XINE__
#define __TYPEDEF_GTK_XINE__
typedef struct _GtkXine GtkXine;
#endif
struct _GtkXine {
	LumPlayer __parent__;
	/*< private >*/
	GtkXinePrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _GtkXineClass GtkXineClass;
struct _GtkXineClass {
	LumPlayerClass __parent__;
	bool (* play) (GtkXine * self);
	void (* load_video_out_driver) (GtkXine * self);
	xine_t * xine;
	int ref;
};


/*
 * Public methods
 */
GType	gtk_xine_get_type	(void);
GtkXine * 	gtk_xine_new	(LumConfig * config);
void 	gtk_xine_set_reparent	(GtkXine * self,
					GdkWindow * parent);
void 	gtk_xine_stream_clean	(GtkXine * self);

/*
 * Argument wrapping macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define GTK_XINE_PROP_SHOW_VFX(arg)    	"show_vfx", __extension__ ({gboolean z = (arg); z;})
#define GTK_XINE_GET_PROP_SHOW_VFX(arg)	"show_vfx", __extension__ ({gboolean *z = (arg); z;})
#define GTK_XINE_PROP_SHOW_VFX_EMBED(arg)    	"show_vfx_embed", __extension__ ({gboolean z = (arg); z;})
#define GTK_XINE_GET_PROP_SHOW_VFX_EMBED(arg)	"show_vfx_embed", __extension__ ({gboolean *z = (arg); z;})
#define GTK_XINE_PROP_POSITION(arg)    	"position", __extension__ ({gdouble z = (arg); z;})
#define GTK_XINE_GET_PROP_POSITION(arg)	"position", __extension__ ({gdouble *z = (arg); z;})
#define GTK_XINE_PROP_TIME(arg)    	"time", __extension__ ({gint z = (arg); z;})
#define GTK_XINE_GET_PROP_TIME(arg)	"time", __extension__ ({gint *z = (arg); z;})
#define GTK_XINE_GET_PROP_IS_SEEKABLE(arg)	"is_seekable", __extension__ ({gboolean *z = (arg); z;})
#define GTK_XINE_PROP_MUTE(arg)    	"mute", __extension__ ({gboolean z = (arg); z;})
#define GTK_XINE_GET_PROP_MUTE(arg)	"mute", __extension__ ({gboolean *z = (arg); z;})
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define GTK_XINE_PROP_SHOW_VFX(arg)    	"show_vfx",(gboolean )(arg)
#define GTK_XINE_GET_PROP_SHOW_VFX(arg)	"show_vfx",(gboolean *)(arg)
#define GTK_XINE_PROP_SHOW_VFX_EMBED(arg)    	"show_vfx_embed",(gboolean )(arg)
#define GTK_XINE_GET_PROP_SHOW_VFX_EMBED(arg)	"show_vfx_embed",(gboolean *)(arg)
#define GTK_XINE_PROP_POSITION(arg)    	"position",(gdouble )(arg)
#define GTK_XINE_GET_PROP_POSITION(arg)	"position",(gdouble *)(arg)
#define GTK_XINE_PROP_TIME(arg)    	"time",(gint )(arg)
#define GTK_XINE_GET_PROP_TIME(arg)	"time",(gint *)(arg)
#define GTK_XINE_GET_PROP_IS_SEEKABLE(arg)	"is_seekable",(gboolean *)(arg)
#define GTK_XINE_PROP_MUTE(arg)    	"mute",(gboolean )(arg)
#define GTK_XINE_GET_PROP_MUTE(arg)	"mute",(gboolean *)(arg)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
